<?php

$db_check = true;

function check_db() {
  global $wpdb, $db_check;
  if($db_check) {
    // Check DB
    if(!$wpdb->dbh) {
      echo('Our database has issues. Try again later.');
    } else {
      echo('We\'re currently having site problems. Try again later.');
    }
    die();
  }
}

function kill_data() {
  return '';
}

function fail($s) {
  header('HTTP/1.0 500 Internal Server Error');
  echo $s;
  exit;
}

if ($_SERVER["REQUEST_METHOD"] != "POST") {
  header('Allow: POST');
  header("HTTP/1.1 405 Method Not Allowed");
  header("Content-type: text/plain");
  exit;
}

ob_start('kill_data');
register_shutdown_function('check_db');
require_once(dirname(__FILE__)."/../../../wp-config.php");
$db_check = false;
ob_end_clean();

nocache_headers();

$comment_post_ID = (int) $_POST['comment_post_ID'];

$status = $wpdb->get_row("SELECT post_status, comment_status FROM $wpdb->posts WHERE ID = '$comment_post_ID'");

if ( empty($status->comment_status) ) {
  do_action('comment_id_not_found', $comment_post_ID);
  fail( __('The post you are trying to comment on does not currently exist in the database.','wpcandyEx') );
} elseif ( 'closed' ==  $status->comment_status ) {
  do_action('comment_closed', $comment_post_ID);
  fail( __('Sorry, comments are closed for this item.','wpcandyEx') );
} elseif ( in_array($status->post_status, array('draft', 'pending') ) ) {
  do_action('comment_on_draft', $comment_post_ID);
  fail( __('The post you are trying to comment on has not been published.','wpcandyEx') );
}

$comment_author       = trim(strip_tags($_POST['author']));
$comment_author_email = trim($_POST['email']);
$comment_author_url   = trim($_POST['url']);
$comment_content      = trim($_POST['comment']);

// If the user is logged in
$user = wp_get_current_user();
if ( $user->ID ) {
  $comment_author       = $wpdb->escape($user->display_name);
  $comment_author_email = $wpdb->escape($user->user_email);
  $comment_author_url   = $wpdb->escape($user->user_url);
  if ( current_user_can('unfiltered_html') ) {
    if ( wp_create_nonce('unfiltered-html-comment_' . $comment_post_ID) != $_POST['_wp_unfiltered_html_comment'] ) {
      kses_remove_filters(); // start with a clean slate
      kses_init_filters(); // set up the filters
    }
  }
} else {
  if ( get_option('comment_registration') )
    fail( __('Sorry, you must be logged in to post a comment.') );
}

$comment_type = '';

if ( get_option('require_name_email') && !$user->ID ) {
  if ( 6 > strlen($comment_author_email) || '' == $comment_author )
    fail( __('Error: please fill the required fields (name, email).','wpcandyEx') );
  elseif ( !is_email($comment_author_email))
    fail( __('Error: please enter a valid email address.','wpcandyEx') );
}

if ( '' == $comment_content )
  fail( __('Error: please type a comment.','wpcandyEx') );


// Simple duplicate check
$dupe = "SELECT comment_ID FROM $wpdb->comments WHERE comment_post_ID = '$comment_post_ID' AND ( comment_author = '$comment_author' ";
if ( $comment_author_email ) $dupe .= "OR comment_author_email = '$comment_author_email' ";
$dupe .= ") AND comment_content = '$comment_content' LIMIT 1";
if ( $wpdb->get_var($dupe) ) {
  fail( __('Duplicate comment detected; it looks as though you\'ve already said that!','wpcandyEx') );
}


$commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'user_ID');

$comment_id = wp_new_comment( $commentdata );

$comment = get_comment($comment_id);
if ( !$user->ID ) {
  setcookie('comment_author_' . COOKIEHASH, $comment->comment_author, time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
  setcookie('comment_author_email_' . COOKIEHASH, $comment->comment_author_email, time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
  setcookie('comment_author_url_' . COOKIEHASH, clean_url($comment->comment_author_url), time() + 30000000, COOKIEPATH, COOKIE_DOMAIN);
}

@header('Content-type: ' . get_option('html_type') . '; charset=' . get_option('blog_charset'));

$comment->comment_type = 'comment';
$comment_index = $_POST['comment_count'] + 1;
?>

<li class="<?php comment_style_class($comment_index);?>" id="comment-<?php comment_ID() ?>">  
  <span class="counter"><?php echo $comment_index; ?></span>
  <cite class="author"><?php comment_author_link() ?></cite>
  <div class="meta">
    <a href="#comment-<?php comment_ID(); ?>" title="Permanent Link to this Comment"><?php comment_date('Y-m-d') ?> <?php comment_time() ?></a>
    <?php edit_comment_link(__('Edit','wpcandyEx'), '<span class="edit">', '</span>');?>
  </div>
  <?php// echo get_avatar( $comment, 32 ); ?>
  <div class="comment"><?php comment_text(); ?></div>
  <?php if ('0' == $comment->comment_approved) { ?><p class="alert"><strong><?php _e('Your comment is awaiting moderation.','wpcandyEx'); ?></strong></p><?php } ?>
</li>