<?php

$WPCandyEx_version = '0.97';
 
$asides_cat_ID = 11;

function the_theme_version() {
  global $WPCandyEx_version;
  echo $WPCandyEx_version;
}

function is_asides_post() {
  global $asides_cat_ID;
  return in_category($asides_cat_ID);
}

function the_robots_rules() {
  if ((is_single() && (!is_asides_post() && !in_category('picture'))) || is_page() || (is_home() && !is_paged())) {
    echo 'index,follow';
  } else {
    echo 'noindex,follow';
  }
}

function the_page_title() {
  // Page or Single Post
  if ( is_page() or is_single() ) {
    the_title();
    // If paged
    global $wp_query;
    $post = $wp_query->post;
    $text = $post->post_content;
    $page = intval(get_query_var('page'));
    $pages = explode('<!--nextpage-->', $text);
    if (count($pages) > 1) {
      if ( !$page )
        $page = 1;
      echo "($page)";
    }
  // Category Archive
  } elseif ( is_category() ) {
    printf( 'Category Archive for &lsquo;%s&rsquo;', single_cat_title('', false) );

  // Tag Archive
  } elseif ( function_exists('is_tag') and function_exists('single_tag_title') and is_tag() ) {
    printf( 'Tag Archive for &lsquo;%s&rsquo;', single_tag_title('', false) );

  // General Archive
  } elseif ( is_archive() ) {
    printf( '%s Archive', wp_title('', false) );

  // Search Results
  } elseif ( is_search() ) {
    printf( 'Search Results for &lsquo;%s&rsquo;', get_query_var('s') );
  }

  // Insert separator for the titles above
  if ( !is_home() and !is_404() ) {
    echo ' - ';
  }

  // Finally the blog name
  echo get_option('blogname');
}

function the_body_class() {
  $class = 'wordpress';
  $class .= ' lang-zh';
  if (is_page()) {
    $class .= ' page';
  }
  if (is_single()) {
    $class .= ' single';
  }
  echo $class;
}

function the_post_class() {
  global $asides_cat_ID;
  $class = 'post';
  if (in_category($asides_cat_ID)){
    $class .= ' asides';
  }
  echo $class;
}

function comment_style_class($comment_index, $echo = true) {
  global $post, $comment;
  $class = '';
  if ( $comment->user_id === $post->post_author )
    $class .= ' bypostauthor';

  if ( $comment_index & 1 == 1) 
    $class .= ' alt';
  
  $class = ltrim($class);

  if ($echo)
    echo $class;

  return $class;
}

// From K2
// http://getk2.com
function the_page_head() {
  global $asides_cat_ID, $wp_query;
  $pagehead = '';
  if (is_category()) {
    if (get_query_var('cat') != $asides_cat_ID) {
      $pagehead = "Archive for the '".single_cat_title('', false)."' Category";
    } else {
      $pagehead = single_cat_title('', false);
    }

  } elseif (is_day()) {
    $pagehead = "Archive for ".get_the_time('F jS, Y');

  } elseif (is_month()) {
    $pagehead = "Archive for ".get_the_time('F, Y');

  } elseif (is_year()) {
    $pagehead = "Archive for ".get_the_time('Y');

  } elseif (is_search()) {
    $pagehead = "Search for '".attribute_escape(stripslashes(get_query_var('s')))."'";

  } elseif (function_exists('is_tag') && is_tag()) {
    if (function_exists('single_tag_title')) {
      $pagehead = "Tag Archive for '".single_tag_title('', false)."'";
    } else {
      $pagehead = "Tag Archive for '".get_query_var('tag')."'";
    }
    
  } elseif (is_author()) {
    $pagehead = "Tag Archive for ".get_author_name(get_query_var('author'));

  } elseif (is_paged() && (get_query_var('paged') > 1)) { 
     $pagehead = "Archive";
  }
  if ( $pagehead ) {
    echo "\n      <div class=\"pagehead\"><h2>$pagehead</h2>\n";
    if ( (get_query_var('paged') > 1) ) {
      printf(__('        <span class="pages">Page %1$s of %2$s</span>','wpcandyEx'), get_query_var('paged'), $wp_query->max_num_pages);
    }
    echo "\n      </div>\n\n";
  }
}

function the_smiles() {
  global $wpsmiliestrans;
  $wpsmiliestrans = array_unique($wpsmiliestrans);
  foreach ( $wpsmiliestrans as $smiley => $img ) {
    $smiley_code = htmlspecialchars(trim($smiley), ENT_QUOTES);
    echo " <img src='/wp-includes/images/smilies/$img' alt='$smiley_code' class='wp-smiley' onclick=\"javascript:insertSmiliey('$smiley_code')\"/> \n";
  }
}

function the_meta_keywords() {
  $keywords = array();
  if (is_single()) {
    global $post;
    $tags = get_the_tags($post->ID);
    if (is_array($tags)) {
      foreach($tags as $tag){
        $keywords[] = $tag->name;
      }
    }
  } elseif (is_home() && !is_paged()) {
    
    global $posts, $wpdb;

    //Get posts ID
    $post_ids = array();
    foreach($posts as $post){
      $post_ids[] = $post->ID;
    }
    if (count($post_ids) == 0) return;
    $postlist = implode( "', '", $post_ids );

    // Get cache
    $key = md5(maybe_serialize($postlist));
    $cache = wp_cache_get('the_head_keywords' , 'wpcandyEx');
    
    // If cache not exist, get datas and add cache
		if ( !isset( $cache[$key] ) ) {
			$results = $wpdb->get_results("
				SELECT t.name AS name, t.term_id AS term_id FROM {$wpdb->posts} AS p
				INNER JOIN {$wpdb->term_relationships} AS tr ON (p.ID = tr.object_id)
				INNER JOIN {$wpdb->term_taxonomy} AS tt ON (tr.term_taxonomy_id = tt.term_taxonomy_id)
				INNER JOIN {$wpdb->terms} AS t ON (tt.term_id = t.term_id)
				WHERE tt.taxonomy = 'post_tag' AND ( p.ID IN ('{$postlist}') )
				GROUP BY t.term_id");
      if (!$results) return;
      foreach ($results as $item) {
        $keywords[] = $item->name;
      }
      // Unique keywords
      $keywords = array_unique($keywords);
			$cache[$key] = $keywords;
			wp_cache_add( 'the_head_keywords', $cache, 'wpcandyEx' );
		} else {
			$keywords = $cache[$key];
		}
    
  }
  if(count($keywords)>0) {
    echo "\n  <meta name=\"keywords\" content=\"".join(', ', $keywords)."\" />\n";
  }
}

// From Head META Description
// http://szub.net
function the_meta_description() {
  /* >> user-configurable variables */
  $default_blog_desc = ''; // default description (setting overrides blog tagline)
  $post_desc_length  = 2; // description length in # words for post/Page
  $post_use_excerpt  = 1; // 0 (zero) to force content as description for post/Page
  $custom_desc_key   = 'description'; // custom field key; if used, overrides excerpt/content
  /* << user-configurable variables */

  if ( is_asides_post() ) return ;

  global $wp_query; 
  if(is_single() || is_page()) {
    $post = $wp_query->post;
    $post_custom = get_post_custom($post->ID);
    if (is_array($post_custom))
      $custom_desc_value = $post_custom[$custom_desc_key][0];

    $page = get_query_var('page');
    if ( !$page )
      $page = 1;

    if (isset($custom_desc_value)) {
      $text = $custom_desc_value;
    } elseif($post_use_excerpt && !empty($post->post_excerpt) && $page == 1) {
      $text = $post->post_excerpt;
    } else {
      $text = $post->post_content;
      if ( $page > 1 ) {
        $pages = explode('<!--nextpage-->', $text);
        $text = $pages[$page-1];
      }
    }

    $text = trim(strip_tags($text));
    // delete line break;
    $text = preg_replace("/(\s*?\r?\n\s*?)+/","\n",$text);
    //print_r($text);die();
    $text = str_replace(array("\""), "", $text);
       
    $text = explode("\n", $text);
    if(count($text) > $post_desc_length) {
      $l = $post_desc_length;
      $ellipsis = '...';
    } else {
      $l = count($text);
      $ellipsis = '';
    }

    $description = '';
    for ($i=0; $i<$l; $i++)
      $description .= $text[$i] . '';

    $description .= $ellipsis;

  } elseif (is_category()) {
    $category = $wp_query->get_queried_object();
    $description = trim(strip_tags($category->category_description));
  } elseif (is_home() && !is_paged()) {
    $description = empty($default_blog_desc) ? trim(strip_tags(get_bloginfo('description'))) : $default_blog_desc;
  } else {
    $description = '';
  }

  $description = trim($description);
  if($description && $description != '...') {
    echo "<meta name=\"description\" content=\"$description\" />";
  }
}

function the_page_navigation() {
?>
      <ul class="nav clearfix">
        <li class="left"><?php next_posts_link('<span>&laquo;</span> Previous Entries'); ?></li>
        <li class="right"><?php previous_posts_link('Next Entries <span>&raquo;</span>'); ?></li>
      </ul>
<?php
}

function the_post_navigation() {
?>
      <ul class="nav clearfix">
        <li class="left"><?php previous_post_link('<span>&laquo;</span> %link') ?></li>
        <li class="right"><?php next_post_link('%link <span>&raquo;</span>') ?></li>
      </ul>
<?php
}

// can't use in WP 2.7
function the_loginout_link_old($before = '<li>', $after = '</li>') {
  $redirect_to = is_single() ? 'redirect_to='.urlencode($_SERVER['REQUEST_URI']) : '';
	if ( ! is_user_logged_in() )
		$link = '<a id="login" href="' . get_option('siteurl') . '/wp-login.php%redirect_to%">' . __('Log in') . '</a>';
	else
		$link = '<a id="logout" href="' . get_option('siteurl') . '/wp-login.php?action=logout%redirect_to%">' . __('Log out') . '</a>';

  if ($redirect_to)
    $redirect_to = (strpos($link, '?') !== false ? "&amp;" : "?") . $redirect_to;

  $link = str_replace('%redirect_to%',$redirect_to,$link);
	echo $before.$link.$after;
}


function the_loginout_link($before = '<li>', $after = '</li>') {
  $redirect_to = is_single() ? 'redirect_to='.urlencode($_SERVER['REQUEST_URI']) : '';
  
  if ( ! is_user_logged_in() )
		$link = '<a id="login" href="' . wp_login_url() . '%redirect_to%">' . __('Log in') . '</a>';
	else
		$link = '<a id="logout" href="' . wp_logout_url() . '%redirect_to%">' . __('Log out') . '</a>';

  if ($redirect_to)
    $redirect_to = (strpos($link, '?') !== false ? "&amp;" : "?") . $redirect_to;

  $link = str_replace('%redirect_to%',$redirect_to,$link);
	echo $before.$link.$after;
}

function remove_nofollow($link) {
  if (strpos($link, 'voidman.com') !== false) {
    $link = str_replace("rel='external nofollow'", '', $link);
  }
  return $link;
}
add_filter('get_comment_author_link', 'remove_nofollow');

function posts_filter($query) {
  global $asides_cat_ID;
  
  if ($query->is_home || $query->is_feed || $query->is_comment_feed || ($query->is_search && !is_admin())) {
    $cats = $query->get('cat');
    $cats .= ',';
    $query->set('cat', $cats . '-' . $asides_cat_ID);
  }

  if ($query->is_home) {
    $query->set('posts_per_page', 5);
  }
  return $query;
}
add_filter('pre_get_posts', 'posts_filter');

function rss_footer($content) {
  if (is_feed()) {
    $link = get_permalink();

    $content .= '<hr />';
    $content .= '<a href="http://www.voidman.com">Voidman.com</a> | Link: <a href="'.$link.'">'.$link.'</a>';
  }
  return $content;
}
add_filter('the_content', 'rss_footer', 100);

function the_related_posts($args) {
  if (function_exists('st_related_posts')){
    st_related_posts($args);
  }
}

if ( function_exists('register_sidebar') )
  register_sidebar(array(
    'before_widget' => '<div id="%1$s" class="widget %2$s">',
    'after_widget' => "</div>\n",
    'before_title' => '<h4>',
    'after_title' => "</h4>\n",
  ));


function sitemap_exclude_categories($where) {
  global $asides_cat_ID, $wpdb;
  $cates = array($asides_cat_ID, 53);
  if (count($cates) > 0) {
    $table_posts = $wpdb->posts;
    $exclude = "(NOT EXISTS (
      SELECT r.object_id FROM {$wpdb->term_relationships} r 
      INNER JOIN {$wpdb->term_taxonomy} t ON r.term_taxonomy_id = t.term_taxonomy_id 
      WHERE t.taxonomy = 'category' AND t.term_id IN (".join(',', $cates).") AND r.object_id = `".$table_posts."`.ID
    ))";
    $where = $exclude.'  AND '.$where;
  }

  return $where;
}
// You will need to add the following code to sitemap-core.php
// $where = apply_filters('sitemap_get_posts_sqlwhere', $where);

//add_filter('sitemap_exclude_categories', 'sitemap_exclude_categories');



function add_schedule_options($schedules) {
  $custom_schedules = array(
    'minutely' => array( 'interval' => 60, 'display' => __('Once Minutely') ),
    'quarterly' => array( 'interval' => 900, 'display' => __('Once Quarterly') ),
    'weekly' => array( 'interval' => 604800, 'display' => __('Once Weekly') ),
    'fortnightly' => array( 'interval' => 1209600, 'display' => __('Once Fortnightly') ),
    'monthly' => array( 'interval' => 2592000, 'display' => __('Once Monthly') ),
  );

  return array_merge($custom_schedules, $schedules);
}
add_filter('cron_schedules', 'add_schedule_options'); 

function delete_post_revisions() {
  global $wpdb;

  // Also need to delete the post meta and term relationships
  $wpdb->query("DELETE FROM {$wpdb->postmeta} WHERE post_id IN (SELECT ID FROM {$wpdb->posts} WHERE post_type = 'revision')");
  $wpdb->query("DELETE FROM {$wpdb->term_relationships} WHERE object_id IN (SELECT ID FROM {$wpdb->posts} WHERE post_type = 'revision')");

  // Delete the post revisions
  $wpdb->query("DELETE FROM {$wpdb->posts} WHERE post_type = 'revision'");
}

// Register the event
add_action('delete_post_revisions_event', 'delete_post_revisions');
if (!wp_next_scheduled('delete_post_revisions_event')) {
  wp_schedule_event(time(), 'weekly', 'delete_post_revisions_event');
}

?>