(function(){

  var DomReady = window.DomReady = {};

  // Everything that has to do with properly supporting our document ready event. Brought over from the most awesome jQuery. 

  var userAgent = navigator.userAgent.toLowerCase();

  // Figure out what browser is being used
  var browser = window.Browser = {
    version: (userAgent.match( /.+(?:rv|it|ra|ie)[\/: ]([\d.]+)/ ) || [])[1],
    safari: /webkit/.test(userAgent),
    opera: /opera/.test(userAgent),
    msie: (/msie/.test(userAgent)) && (!/opera/.test( userAgent )),
    mozilla: (/mozilla/.test(userAgent)) && (!/(compatible|webkit)/.test(userAgent))
  };    

  var readyBound = false;  
  var isReady = false;
  var readyList = [];

  // Handle when the DOM is ready
  function domReady() {
    // Make sure that the DOM is not already loaded
    if(!isReady) {
      // Remember that the DOM is ready
      isReady = true;
      if(readyList) {
        for(var fn = 0; fn < readyList.length; fn++) {
          readyList[fn].call(window, []);
        }
        
        readyList = [];
      }
    }
  };

  // From Simon Willison. A safe way to fire onload w/o screwing up everyone else.
  function addLoadEvent(func) {
    var oldonload = window.onload;
    if (typeof window.onload != 'function') {
      window.onload = func;
    } else {
      window.onload = function() {
        if (oldonload) {
          oldonload();
        }
        func();
      }
    }
  };

  // does the heavy work of working through the browsers idiosyncracies (let's call them that) to hook onload.
  function bindReady() {
    if(readyBound) {
      return;
    }
  
    readyBound = true;

    // Mozilla, Opera (see further below for it) and webkit nightlies currently support this event
    if (document.addEventListener && !browser.opera) {
      // Use the handy event callback
      document.addEventListener("DOMContentLoaded", domReady, false);
    }

    // If IE is used and is not in a frame
    // Continually check to see if the document is ready
    if (browser.msie && window == top) (function(){
      if (isReady) return;
      try {
        // If IE is used, use the trick by Diego Perini
        // http://javascript.nwbox.com/IEContentLoaded/
        document.documentElement.doScroll("left");
      } catch(error) {
        setTimeout(arguments.callee, 0);
        return;
      }
      // and execute any waiting functions
      domReady();
    })();

    if(browser.opera) {
      document.addEventListener( "DOMContentLoaded", function () {
        if (isReady) return;
        for (var i = 0; i < document.styleSheets.length; i++)
          if (document.styleSheets[i].disabled) {
            setTimeout( arguments.callee, 0 );
            return;
          }
        // and execute any waiting functions
        domReady();
      }, false);
    }

    if(browser.safari) {
        var numStyles;
      (function(){
        if (isReady) return;
        if (document.readyState != "loaded" && document.readyState != "complete") {
          setTimeout( arguments.callee, 0 );
          return;
        }
        if (numStyles === undefined) {
          var links = document.getElementsByTagName("link");
          for (var i=0; i < links.length; i++) {
            if(links[i].getAttribute('rel') == 'stylesheet') {
              numStyles++;
            }
          }
          var styles = document.getElementsByTagName("style");
          numStyles += styles.length;
        }
        if (document.styleSheets.length != numStyles) {
          setTimeout( arguments.callee, 0 );
          return;
        }
      
        // and execute any waiting functions
        domReady();
      })();
    }

    // A fallback to window.onload, that will always work
      addLoadEvent(domReady);
  };

  // This is the public function that people can use to hook up ready.
  DomReady.ready = function(fn, args) {
    // Attach the listeners
    bindReady();
    
    // If the DOM is already ready
    if (isReady) {
      // Execute the function immediately
      fn.call(window, []);
    } else {
      // Add the function to the wait list
      readyList.push( function() { return fn.call(window, []); } );
    }
  };
    
  bindReady();
  
})();

//var userAgent = navigator.userAgent.toLowerCase();
//var is_opera = userAgent.indexOf('opera') != -1 && opera.version();
//var is_moz = (navigator.product == 'Gecko') && userAgent.substr(userAgent.indexOf('firefox') + 8, 3);
//var is_ie = (userAgent.indexOf('msie') != -1 && !is_opera) && userAgent.substr(userAgent.indexOf('msie') + 5, 3);

var is_opera = Browser.opera;
var is_moz = Browser.mozilla;
var is_ie = Browser.msie;

function __attachEvent(evt, callback) {   
  if (window.addEventListener) {   
    window.addEventListener(evt, callback, false);    
  } else if (window.attachEvent) {   
    window.attachEvent("on" + evt, callback);   
  }   
} 

function $(id) {
  return document.getElementById(id);
}

document.getElementsByClassName = function(classNames, parentNode) {
  if (!classNames) return;
  var d = parentNode || document;
  var stacks = d.getElementsByTagName('*');
  var re = new RegExp('\\b('+classNames+')\\b');
  var elements = new Array();
  for (var i=0, j=stacks.length; i<j; i++) {
    if (stacks[i].className.match(re) != null){
      elements.push(stacks[i]); 
    }
  }
  re = stacks = d = null;
  return elements.length == 0 ? null : elements;
} 

function include_js(file, callback) {
  var _doc = document.getElementsByTagName('head')[0];
  var js = document.createElement('script');
  js.setAttribute('type', 'text/javascript');
  js.setAttribute('src', file);
  _doc.appendChild(js);

  if (!/*@cc_on!@*/0) { //if not IE
    //Firefox2Firefox3Safari3.1+Opera9.6+ support js.onload
    js.onload = function () {
      callback();
    }
  } else {
    //IE6IE7 support js.onreadystatechange
    js.onreadystatechange = function () {
      if (js.readyState == 'loaded' || js.readyState == 'complete') {
        callback();
      }
    }
  }

  return false;
}

//////////////////////////////

function blogrollOpenNew() {
  if ($('links')) {
    var items = $('links').getElementsByTagName('A');
    for (var i=0; i<items.length; i++) {
      items[i].style.paddingTop = '1px';
      items[i].style.paddingLeft = '20px';
      items[i].style.background = 'url(http://www.google.com/s2/favicons?domain_url=' + items[i].href + ') left center no-repeat';

      items[i].onclick = function() {
        window.open(this.href);
        return false;
      }
    }
  }
}

function openLinkOnNewWin(parentNode) {
  if ($(parentNode)) {
    var items = $(parentNode).getElementsByTagName('A');
    for (var i=0; i<items.length; i++) { 
      if (items[i].rel.indexOf('external') == -1)
        continue;
     
      items[i].onclick = function() {
        window.open(this.href);
        return false;
      }
    }
  }
}

function setCssStyle(e, css) {
  e.style.cssText = css;
}

function wrapCode() {
  var els = document.getElementsByTagName('pre');
  if (is_ie) {
    for (var i=0, j=els.length; i<j; i++) 
      setCssStyle(els[i], 'word-wrap: break-word; zoom:1;');
  } else {
    for (var i=0, j=els.length; i<j; i++) 
      setCssStyle(els[i], 'white-space: -moz-pre-wrap; white-space: -o-pre-wrap; white-space: -pre-wrap; white-space: pre-wrap;');
  }
}

function setCommentStyle() {
  if (is_ie) 
    return;
  var e = $('comments');
  if (!e) 
    return;
  var els = document.getElementsByClassName('bypostauthor|alt', e);
  if (!els) 
    return;
  var style = "border-radius: 5px;-moz-border-radius: 5px;-khtml-border-radius: 5px;-webkit-border-radius: 5px;";
  for (var i=0, j=els.length; i<j; i++) {
    setCssStyle(els[i], style);
  }
}

function insertSmiliey(strCode) {
  var txtarea = $('comment');
  strCode = ' ' + strCode + ' ';
  if (txtarea.createTextRange && txtarea.caretPos) { // for IE, Opera
    var caretPos = txtarea.caretPos;
    caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? strCode + ' ' : strCode;
  } else if(txtarea.selectionStart || txtarea.selectionStart == '0'){// for Firefox, Safari 
    var startPos = txtarea.selectionStart; 
    var endPos = txtarea.selectionEnd; 
    txtarea.value = txtarea.value.substring(0, startPos) 
      + strCode 
      + txtarea.value.substring(endPos, txtarea.value.length);  
    txtarea.selectionStart = txtarea.selectionEnd = startPos + strCode.length; 
  } else {
    txtarea.value  += strCode;
  }
  txtarea.focus();
}

function storeCaret(obj) {
  if (obj.createTextRange) 
    obj.caretPos = document.selection.createRange().duplicate();
}



function replyto(commentid, commenter) {
  var txtarea = $('comment');
  txtarea.value += '<a class="replyto" href="#comment-' + commentid + '">@' + commenter + ':</a> ';
  window.location.href = window.location.href.split('#')[0] + '#commentform';
  txtarea.focus();
}

function ctlent(event) {
  e = event ? event : window.event;
	if(!ctlent.submitted && ((e.ctrlKey && e.keyCode == 13) || (e.altKey && e.keyCode == 83)) && $('submit') && $('comment').value) {
		ctlent.submitted = true;
    $('submit').click();
		$('submit').disabled = true;
	}
}

function addGoogleFriendConnectGadget() {
  if (!$('google_fc_wrapper'))
    return false;

  var skin = {};
  skin['HEIGHT'] = '300';
  skin['BORDER_COLOR'] = '#cccccc';
  skin['ENDCAP_BG_COLOR'] = '#e0ecff';
  skin['ENDCAP_TEXT_COLOR'] = '#333333';
  skin['ENDCAP_LINK_COLOR'] = '#0000cc';
  skin['ALTERNATE_BG_COLOR'] = '#ffffff';
  skin['CONTENT_BG_COLOR'] = '#ffffff';
  skin['CONTENT_LINK_COLOR'] = '#0000cc';
  skin['CONTENT_TEXT_COLOR'] = '#333333';
  skin['CONTENT_SECONDARY_LINK_COLOR'] = '#7777cc';
  skin['CONTENT_SECONDARY_TEXT_COLOR'] = '#666666';
  skin['CONTENT_HEADLINE_COLOR'] = '#333333';

  google.friendconnect.container.setParentUrl('/' /* location of rpc_relay.html and canvas.html */);
  google.friendconnect.container.renderMembersGadget(
   { id: 'google_fc_wrapper',
     site: '14066144282462464120'},
    skin);

  if (!is_ie) 
    $('google_fc_wrapper').style.height = skin['HEIGHT'] + 'px';
}

//////////////////////////////

DomReady.ready(function(){
  wrapCode();
  setCommentStyle();
  blogrollOpenNew();
  openLinkOnNewWin('comments');
  openLinkOnNewWin('recent-comments');
  //include_js('http://www.google.com/friendconnect/script/friendconnect.js', addGoogleFriendConnectGadget);
});